'use strict';

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _ = require('../');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var start = new Date().getTime();

function msToTime(mstime) {
  var ms = parseInt(mstime % 1000 / 100),
      s = parseInt(mstime / 1000 % 60),
      m = parseInt(mstime / (1000 * 60) % 60),
      h = parseInt(mstime / (1000 * 60 * 60) % 24);
  h = h < 10 ? "0" + h : h;
  m = m < 10 ? "0" + m : m;
  s = s < 10 ? "0" + s : s;
  return h + ':' + m + ':' + s + '.' + ms;
}

[
// 'www.fab.com',
'www.ibis.com', 'www.mercure.com', 'www.novotel.com'].forEach(function (siteConfig) {
  var sitePath = _.config.root = _.config.root.replace(/([\da-z\.-]+)\.([a-z\.]{2,6})([\/\w \.-]*)*?$/, siteConfig);

  if (siteConfig !== 'www.fab.com') {
    _.config.files.templates.extension = 'shtml';
  }

  var data = _.config.data.url;
  var publishUrl = _.config.publish.url;
  var jsonFiles = _.FileParser.getFiles(_.fileUtils.concatPath(sitePath, data), true, 10);
  jsonFiles.forEach(function (jsonFile) {
    var resp = _fsExtra2.default.readJsonSync(jsonFile.path);
    var res = (0, _.save)(_.fileUtils.concatPath(sitePath, publishUrl, resp.abe_meta.link), _.fileUtils.concatPath(sitePath, resp.abe_meta.template.replace(sitePath, '')), resp, null, 'publish');
  });
});

console.log('Page generation time ' + msToTime(new Date().getTime() - start));