'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _dirCompare = require('dir-compare');

var _dirCompare2 = _interopRequireDefault(_dirCompare);

var _mkdirp = require('mkdirp');

var _mkdirp2 = _interopRequireDefault(_mkdirp);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _ = require('../');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var FileUtils = function () {
	function FileUtils() {
		_classCallCheck(this, FileUtils);
	}

	_createClass(FileUtils, null, [{
		key: 'pathWithRoot',
		value: function pathWithRoot(path) {
			if (typeof path === 'undefined' || path === null || path === '') path = '';
			return FileUtils.concatPath(_.config.root, path.replace(_.config.root, '')).replace(/\/$/, "");
		}
	}, {
		key: 'cleanPath',
		value: function cleanPath(path) {
			if (typeof path !== 'undefined' && path !== null) path = path.replace(/\/$/, "");
			return path;
		}
	}, {
		key: 'concatPath',
		value: function concatPath() {
			var path = '';
			Array.prototype.forEach.call([].slice.call(arguments), function (argument) {
				if (path !== '') argument = argument.replace(/^\//, "");
				path += FileUtils.cleanPath(argument) + '/';
			});

			path = FileUtils.cleanPath(path);

			return path;
		}
	}, {
		key: 'removeLast',
		value: function removeLast(path) {
			return path.substring(0, FileUtils.cleanPath(path).lastIndexOf('/'));
		}
	}, {
		key: 'replaceExtension',
		value: function replaceExtension(path, ext) {
			return path.substring(0, path.lastIndexOf('.')) + '.' + ext;
		}
	}, {
		key: 'removeExtension',
		value: function removeExtension(path) {
			return path.substring(0, path.lastIndexOf('.'));
		}
	}, {
		key: 'filename',
		value: function filename(path) {
			return FileUtils.cleanPath(path).substring(FileUtils.cleanPath(path).lastIndexOf('/') + 1);
		}
	}, {
		key: 'isFile',
		value: function isFile(path) {
			try {
				var stat = _fsExtra2.default.statSync(path);
				return true;
			} catch (e) {
				return false;
			}
			return false;
		}
	}, {
		key: 'isValidFile',
		value: function isValidFile(fileName) {
			var dotPosition = fileName.indexOf('.');
			if (dotPosition > 0) return true;
			return false;
		}
	}, {
		key: 'cleanTplName',
		value: function cleanTplName(path) {
			var cleanTplName = _.fileAttr.delete(path);
			cleanTplName = cleanTplName.replace(_.config.root, '');
			cleanTplName = cleanTplName.split('/');
			cleanTplName.shift();
			return cleanTplName.join('/');
		}
	}, {
		key: 'cleanFilePath',
		value: function cleanFilePath(path) {
			var cleanFilePath = _.fileAttr.delete(path);
			cleanFilePath = cleanFilePath.replace(_.config.root + '/', '');
			cleanFilePath = cleanFilePath.split('/');
			cleanFilePath.shift();
			return cleanFilePath.join('/');
		}
	}, {
		key: 'getFilePath',
		value: function getFilePath(path) {
			var res = null;
			if (typeof path !== 'undefined' && path !== null && path !== '') {
				res = path.replace(_.config.root + '/');
				res = FileUtils.concatPath(_.config.root, _.config.draft.url, res);
			}
			return res;
		}
	}, {
		key: 'getTemplatePath',
		value: function getTemplatePath(path) {
			var res = null;
			if (typeof path !== 'undefined' && path !== null && path !== '') {
				res = path.replace(_.config.root + '/');
				res = FileUtils.concatPath(_.config.root, _.config.templates.url, res);
			}
			return res;
		}
	}, {
		key: 'mergeFiles',
		value: function mergeFiles(files1, files2) {
			var merged = {};

			Array.prototype.forEach.call(files1, function (file1) {
				var cleanFilePath1 = file1.cleanFilePath;
				merged[cleanFilePath1] = [file1];
				var date1 = new Date(file1.date);

				Array.prototype.forEach.call(files2, function (file2) {
					var cleanFilePath2 = file2.cleanFilePath;
					var date2 = new Date(file2.date);
					if (cleanFilePath1 === cleanFilePath2) {
						if (date2 >= date1) {
							merged[cleanFilePath1] = [file2];
						} else {
							merged[cleanFilePath1].push(file2);
						}
					}
				});
			});

			Array.prototype.forEach.call(files2, function (file2) {
				var cleanFilePath2 = file2.cleanFilePath;

				if (typeof merged[cleanFilePath2] === 'undefined' || merged[cleanFilePath2] === null) {
					merged[cleanFilePath2] = [file2];
				}
			});

			return merged;
		}
	}]);

	return FileUtils;
}();

exports.default = FileUtils;