'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.abeEngine = undefined;
exports.compileAbe = compileAbe;
exports.attrAbe = attrAbe;
exports.testObj = testObj;
exports.closeBlock = closeBlock;
exports.openBlock = openBlock;
exports.subBlock = subBlock;
exports.printInput = printInput;
exports.moduloIf = moduloIf;
exports.className = className;
exports.printJson = printJson;
exports.folders = folders;
exports.printConfig = printConfig;
exports.notEmpty = notEmpty;

var _handlebars = require('handlebars');

var _handlebars2 = _interopRequireDefault(_handlebars);

var _ = require('../');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var singleton = Symbol();
var singletonEnforcer = Symbol();

var abeEngine = function () {
  function abeEngine(enforcer) {
    _classCallCheck(this, abeEngine);

    if (enforcer != singletonEnforcer) throw "Cannot construct Json singleton";
    this._content = {};
  }

  _createClass(abeEngine, [{
    key: 'content',
    get: function get() {
      return this._content;
    },
    set: function set(content) {
      this._content = content;
    }
  }], [{
    key: 'instance',
    get: function get() {
      if (!this[singleton]) {
        this[singleton] = new abeEngine(singletonEnforcer);
      }
      return this[singleton];
    }
  }]);

  return abeEngine;
}();

exports.abeEngine = abeEngine;

/**
 * Abe handlebar helper, that retrieve text to add to handlebars templating engine
 * @return {String} the string to replace {{ handlebars_key }}
 */

function compileAbe() {
  var content = abeEngine.instance.content;
  var keyAttr = typeof arguments[0].hash['key_text'] !== 'undefined' ? 'key_text' : 'key';

  if (arguments[0].hash[keyAttr].indexOf(']-') > 0) {

    var key = arguments[0].hash[keyAttr].split('-');
    key = key[key.length - 1];
    var hash = arguments[0].hash;
    return new _handlebars2.default.SafeString(content ? content[hash['dictionnary']][arguments[0].data.index][key] : hash.key);
  }

  var key = arguments[0].hash[keyAttr].replace('.', '-');

  var hash = arguments[0].hash;
  var value = content ? content[hash.key.replace('.', '-')] : hash.key;
  if (typeof value === 'undefined' || value === null) {
    value = '';
  }
  return new _handlebars2.default.SafeString(value);
}

/**
 * Print properties inside html tag
 * @param  {String} attr exemple: atl, title, ...
 * @param  {[type]} value value of the property
 * @return {String} the value to print inside the attribut
 */
function attrAbe(attr, value) {
  var content = abeengine._content;
  return new _handlebars2.default.SafeString(value);
}

function testObj(ctx) {
  console.log(ctx);
  console.log('\n\n----------\n\n');
}

var currentBlock = '';
var currentIndex = -1;
var countBlock = 0;

function closeBlock(ctx) {
  var res = '';
  if (ctx === 1) {
    currentBlock = '';
    currentIndex = -1;
    if (countBlock > 0) for (var i = 0; i < countBlock; i++) {
      res += '</div>';
    }countBlock = 0;
    return res;
  }
  if (ctx === 2) {
    var res = '';
    if (countBlock > 0) for (var i = 0; i < countBlock; i++) {
      res += '</div>';
    }countBlock = 0;
    return res;
  }
  if (ctx === 3) {
    for (var i = 0; i < countBlock; i++) {
      res += '</div>';
    }countBlock = 0;
    return res;
  }
  if (ctx[0].block !== '') {
    res += '</div>';
  } else if (ctx[0].key.indexOf('[') > -1) {
    res += '</div>\n          </div>\n            <button type="button" class="btn btn-default add-block" >\n              <span class="glyphicon glyphicon-plus" aria-hidden="true"></span>\n            </button><button type="button" class="btn btn-default remove-block" >\n              <span class="glyphicon glyphicon-minus" aria-hidden="true"></span>\n            </button>';
    currentBlock = '';
  }

  return res;
}

function openBlock(ctx) {
  var res = '';
  if (ctx[0].block !== '') {
    res += '<div class=\'single-block well well-sm\'>\n              <h4 class="title">' + ctx[0].block + ' :</h4>';
  } else if (ctx[0].key.indexOf('[') > -1) {
    currentIndex = -1;
    countBlock++;
    var ctxBlock = ctx[0].key.split('[')[0];
    res += '<div class="list-group" data-block="' + ctxBlock + '" >\n              <h4 class="list-group-head">\n                Bloc name : ' + ctxBlock + '\n              </h4>';

    currentBlock = ctxBlock;
  }

  return res;
}

function subBlock(ctx) {
  var res = '';
  var index = ctx.key.match(/[^\[\]]+?(?=\])/);
  if (index) {
    index = index[0];
    var ctxIndex = ctx.key.split(']')[0].replace(/\[/, '');
    if (currentIndex !== index) {
      var openIngSubBlock = '<div class="list-group-item" data-block="' + ctxIndex + '" >\n                              <button type="button" class="btn btn-info collapsed" data-toggle="collapse" data-target="#' + ctxIndex + '" >\n                                <span class="glyphicon glyphicon-chevron-down" aria-hidden="true"></span>\n                              </button>\n                              <div id="' + ctxIndex + '" class="collapse" >';
      res = index <= 0 ? openIngSubBlock : '</div></div>' + openIngSubBlock;
      currentIndex = index;
    }
  }

  return res;
}

/**
 * Print form input based on input data type {Textarea | text | meta | link | image | ...}
 * && add appropriate attributs / data-attributs
 * @return {String|html} input / input group ...
 */
function printInput() {
  var params = arguments[0],
      res = '<label for="' + params.key + '" \n                    ' + (params.type.indexOf('text_link') > -1 ? 'data-for-link="' + params.key + '"' : '') + ' >\n              ' + params.description + '\n             </label>',
      disabled = '';

  if (typeof params.placeholder === 'undefined' || params.placeholder === null || params.placeholder === 'undefined') {
    params.placeholder = '';
  }

  if (typeof params.value === 'undefined' || params.value === null) {
    params.value = '';
  }

  if (typeof params.source !== 'undefined' && params.source !== null) {
    var multiple = '';
    var disabled = '';
    if (typeof params.maxLength === 'undefined' || params.maxLength === null || params.maxLength === '' || params.maxLength > 1 && params.source.length > 0) {
      multiple = 'multiple';
    }
    if (params.source.length <= 0) {
      disabled = 'disabled';
    }
    var lastValues = JSON.stringify(params.value);

    res += '<select ' + multiple + ' ' + disabled + ' class="form-control form-abe"\n                      id="' + params.key + '"\n                      data-id="' + params.key + '"\n                      value=\'\'\n                      last-values=\'' + lastValues + '\'\n                      maxlength="' + params.maxLength + '"\n                      placeholder="' + params.placeholder + '" >\n            <option value=\'\'></option>';

    Array.prototype.forEach.call(params.source, function (val) {
      var hiddenVal = val;
      var selected = '';

      if ((typeof hiddenVal === 'undefined' ? 'undefined' : _typeof(hiddenVal)) === 'object' && Object.prototype.toString.call(hiddenVal) === '[object Object]') {
        hiddenVal = JSON.stringify(hiddenVal).replace(/'/g, "&apos;");
        if (typeof params.display !== 'undefined' && params.display !== null && typeof val[params.display] !== 'undefined' && val[params.display]) {
          val = val[params.display];
        } else {
          val = val[Object.keys(val)[0]];
        }
      }

      if (_typeof(params.value) === 'object' && Object.prototype.toString.call(params.value) === '[object Array]') {
        Array.prototype.forEach.call(params.value, function (v) {
          var item = v;
          if ((typeof v === 'undefined' ? 'undefined' : _typeof(v)) === 'object' && Object.prototype.toString.call(v) === '[object Object]') {
            item = v[Object.keys(v)[0]];
          }
          if (val === item) {
            selected = 'selected="selected"';
          }
        });
      } else if (params.value === hiddenVal) {
        selected = 'selected="selected"';
      }
      res += '<option value=\'' + hiddenVal + '\' ' + selected + '>' + val + '</option>';
    });

    res += '</select>';
  } else if (params.type.indexOf("rich") >= 0) {
    res += '<div class="wysiwyg-container rich">\n              <div class="wysiwyg-toolbar wysiwyg-toolbar-top">\n                <a class="wysiwyg-toolbar-icon" href="#" title="Bold (Ctrl+B)" hotkey="b" data-action="bold" data-param="">\n                  <span class="glyphicon glyphicon-bold"></span>\n                </a>\n                <a class="wysiwyg-toolbar-icon" href="#" title="Italic (Ctrl+I)" hotkey="i" data-action="italic" data-param="">\n                  <span class="glyphicon glyphicon-italic"></span>\n                </a>\n                <a class="wysiwyg-toolbar-icon" href="#" title="Underline (Ctrl+U)" hotkey="u" data-action="underline" data-param="">\n                  <span class="glyphicon underline">U</span>\n                </a>\n                <a class="wysiwyg-toolbar-icon" href="#" title="Text color" data-action="forecolor" data-param="" data-popup="color">\n                  <span class="glyphicon glyphicon-text-color"></span>\n                </a>\n                <a class="wysiwyg-toolbar-icon" href="#" title="Background color" data-action="highlight" data-param="" data-popup="color">\n                  <span class="glyphicon glyphicon-text-background"></span>\n                </a>\n                <a class="wysiwyg-toolbar-icon" href="#" title="Left" data-action="align" data-param="left">\n                  <span class="glyphicon glyphicon-object-align-left"></span>\n                </a>\n                <a class="wysiwyg-toolbar-icon" href="#" title="Center" data-action="align" data-param="center">\n                  <span class="glyphicon glyphicon-object-align-vertical"></span>\n                </a>\n                <a class="wysiwyg-toolbar-icon" href="#" title="Right" data-action="align" data-param="right">\n                  <span class="glyphicon glyphicon-object-align-right"></span>\n                </a>\n                <a class="wysiwyg-toolbar-icon" href="#" title="Justify" data-action="justify" data-param="justify">\n                  <span class="glyphicon glyphicon-menu-hamburger"></span>\n                </a>\n                <a class="wysiwyg-toolbar-icon" href="#" title="Subscript" data-action="subscript" data-param="">\n                  <span class="glyphicon glyphicon-subscript"></span>\n                </a>\n                <a class="wysiwyg-toolbar-icon" href="#" title="Superscript" data-action="superscript" data-param="">\n                  <span class="glyphicon glyphicon-superscript"></span>\n                </a>\n                <a class="wysiwyg-toolbar-icon" href="#" title="Indent" data-action="indent" data-param="">\n                  <span class="glyphicon glyphicon-triangle-right"></span>\n                </a>\n                <a class="wysiwyg-toolbar-icon" href="#" title="Outdent" data-action="indent" data-param="outdent">\n                  <span class="glyphicon glyphicon-triangle-left"></span>\n                </a>\n                <a class="wysiwyg-toolbar-icon" href="#" title="Unordered list" data-action="insertList" data-param="">\n                  <span class="glyphicon glyphicon-th-list"></span>\n                </a>\n                <a class="wysiwyg-toolbar-icon" href="#" title="Remove format" data-action="removeFormat" data-param="">\n                  <span class="glyphicon glyphicon-remove"></span>\n                </a>\n              </div>\n              <textarea class="form-control form-abe form-rich"\n                        id="' + params.key + '"\n                        data-id="' + params.key + '"\n                        maxlength="' + params.maxLength + '"\n                        rows="4"\n                        placeholder="' + params.placeholder + '" >' + params.value + '</textarea>\n            </div>';
  } else if (params.type.indexOf("file") >= 0) {
    res += '<input class="form-control"\n                   data-id="' + params.key + '"\n                   value="' + params.value + '"\n                   name="' + params.key + '"\n                   type="file" />\n            <span class="percent"></span>\n            <input type="text"\n                   class="form-control form-abe hidden"\n                   id="' + params.key + '"\n                   data-id="' + params.key + '"\n                   value="' + params.value + '"\n                   maxlength="' + params.maxLength + '"\n                   placeholder="' + params.placeholder + '" />';
  } else if (params.type.indexOf("textarea") >= 0) {
    res += '<textarea class="form-control form-abe"\n                      id="' + params.key + '"\n                      data-id="' + params.key + '"\n                      value="' + params.value + '"\n                      maxlength="' + params.maxLength + '"\n                      rows="4"\n                      placeholder="' + params.placeholder + '" >' + params.value + '</textarea>';
  } else if (params.type.indexOf("link") >= 0) {
    res += '<div class="input-group">\n            <div class="input-group-addon link">\n              <span class="glyphicon glyphicon-link" aria-hidden="true"></span>\n            </div>\n            <input  type="text"\n                    class="form-control"\n                    id="' + params.key + '"\n                    data-id="' + params.key + '"\n                    value="' + params.value + '"\n                    maxlength="' + params.maxLength + '"\n                    placeholder="' + params.placeholder + '" />\n          </div>';
  } else if (params.type.indexOf("image") >= 0) {
    res += '<div class="input-group">\n            <div class="input-group-addon image">\n              <span class="glyphicon glyphicon-picture" aria-hidden="true"></span>\n            </div>\n            <input  type="text"\n                    class="form-control form-abe"\n                    id="' + params.key + '"\n                    data-id="' + params.key + '"\n                    value="' + params.value + '"\n                    maxlength="' + params.maxLength + '"\n                    placeholder="' + params.placeholder + '" />\n          </div>';
  } else {
    res += '<div class="input-group">\n            <div class="input-group-addon">\n              <span class="glyphicon glyphicon-font" aria-hidden="true"></span>\n              </div>\n              <input  ' + disabled + '\n                      type="text"\n                      class="form-control form-abe"\n                      id="' + params.key + '"\n                      data-id="' + params.key + '"\n                      value="' + params.value + '"\n                      maxlength="' + params.maxLength + '"\n                      placeholder="' + params.placeholder + '" />\n            </div>';
  }
  return res;
}

/**
 * Handlebars helper, conditionnal modulo
 * @param  {Int} num number to test
 * @param  {Int} mod modulo number
 * @param  {String} block text block content inside of {{#moduloIf}} ... {{/moduloIf}}
 * @return {String|html} if true return the block compiled by handlebar inside our template, if not void
 */
function moduloIf(num, mod, block) {
  if (parseInt(num + 1) % parseInt(mod) === 0) {
    return block.fn(this);
  }
}

/**
 * Handlebars helper, to print className and escape it string
 */
function className(str) {
  return str.replace(/\.| |\#/g, '_');
}

/**
 * Handlebars helper, to print json object
 */
function printJson(obj) {
  return JSON.stringify(obj);
}

function recursiveFolder(obj) {
  var index = arguments.length <= 1 || arguments[1] === undefined ? 1 : arguments[1];
  var dataShow = arguments.length <= 2 || arguments[2] === undefined ? '' : arguments[2];

  var classHidden = '';
  if (index > 1) {
    classHidden = 'hidden';
  }

  var id = 'level-' + index;
  if (typeof dataShow !== 'undefined' && dataShow !== null && dataShow !== '') {
    id += '-' + dataShow;
  }

  var res = '<div class="form-group level-' + index + ' ' + classHidden + '" data-shown="' + dataShow + '">\n    <label for="' + id + '" class="col-sm-5 control-label">Level ' + index + '</label>\n    <div class="col-sm-7">\n      <select data-show-hide-sub-folder="true" id="' + id + '" class="form-control">\n        <option data-level-hide="' + (index + 1) + '"></option>';

  var sub = '';

  Array.prototype.forEach.call(obj, function (o) {
    res += '<option data-level-hide="' + (index + 2) + '" data-level-show="' + (index + 1) + '" data-show="' + o.name.replace(/\.| |\#/g, '_') + '">' + o.name + '</option>';

    if (typeof o.folders !== 'undefined' && o.folders !== null && o.folders.length > 0) {
      sub += recursiveFolder(o.folders, index + 1, o.name.replace(/\.| |\#/g, '_'));
    }
  });

  res += '</select>\n    </div>\n  </div>';

  res += sub;

  return res;
}

function folders(obj) {
  var res = recursiveFolder(obj);

  return res;
}

function recursivePrintConfig(obj) {
  var key = arguments.length <= 1 || arguments[1] === undefined ? '' : arguments[1];

  var res = '';

  if ((typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) === 'object' && Object.prototype.toString.call(obj) === '[object Object]') {
    Array.prototype.forEach.call(Object.keys(obj), function (k) {
      var strKey = key;
      if (strKey !== '') {
        strKey += '.';
      }
      strKey += k;
      res += recursivePrintConfig(obj[k], strKey);
    });
  } else {
    res += '<div class="form-group">\n      <label class="col-sm-4 control-label" for="' + key + '">' + key + '</label>\n      <div class="col-sm-8">\n        <input type="text" class="form-control" id="' + key + '" placeholder="' + obj + '" value="' + obj + '">\n      </div>\n    </div>';
  }

  return res;
}

function printConfig(obj) {
  var res = recursivePrintConfig(obj);

  return res;
}

/**
 */
function notEmpty(variable) {
  if (typeof variable !== 'undefined' && variable !== null && variable !== '') {
    return block.fn(this);
  } else {
    return '';
  }
  // }
}