#!/usr/bin/env node
'use strict';

var _Create = require('./cli/Create');

var _Create2 = _interopRequireDefault(_Create);

var _exec = require('exec');

var _exec2 = _interopRequireDefault(_exec);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var userArgs = process.argv.slice(2);
var create = new _Create2.default();

var port = false;
if (typeof userArgs[1] !== 'undefined' && userArgs[1] !== null && /(^[1-9]{1}$|^[0-9]{2,4}$|^[0-9]{3,4}$|^[1-5]{1}[0-9]{1}[0-9]{1}[0-9]{1}[0-9]{1}$|^[1-6]{1}[0-4]{1}[0-9]{1}[0-9]{1}[0-9]{1}$|^[1-6]{1}[0-5]{1}[0-4]{1}[0-9]{1}[0-9]{1}$|^[1-6]{1}[0-5]{1}[0-5]{1}[0-3]{1}[0-5]{1}$)/.test(userArgs[1])) {
	port = userArgs[1];
}

if (typeof userArgs[0] !== 'undefined' && userArgs[0] !== null) {

	switch (userArgs[0]) {
		case 'create':
			if (userArgs[1]) create.init(userArgs[1]);else console.error("Error: no project path specified");
			break;
		case 'serve':
			var dir = process.cwd();
			var command = 'OPENURL=1 ROOT=' + dir + ' npm run start';
			if (port) command = 'PORT=' + port + ' ' + command;
			process.chdir(__dirname + '/../');
			console.log(command);
			(0, _exec2.default)(command, function (err, out, code) {
				if (err instanceof Error) throw err;
				process.stderr.write(err);
				process.stdout.write(out);
				process.exit(code);
			});
			break;
		case 'servedev':
			var dir = process.cwd();
			var command = 'OPENURL=1 ROOT=' + dir + ' npm run startdev';
			if (port) command = 'PORT=' + port + ' ' + command;
			process.chdir(__dirname + '/../');
			console.log(command);
			(0, _exec2.default)(command, function (err, out, code) {
				if (err instanceof Error) throw err;
				process.stderr.write(err);
				process.stdout.write(out);
				process.exit(code);
			});
			break;
		case 'stop':
			(0, _exec2.default)('pm2 delete all', function (err, out, code) {
				if (err instanceof Error) throw err;
				process.stderr.write(err);
				process.stdout.write(out);
				process.exit(code);
			});
			break;
		default:
			console.log("Help: use `create` or `serve` command");
			break;
	}
} else {
	console.log("Help: use `create` or `serve` command");
}