'use strict';

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

var _bodyParser = require('body-parser');

var _bodyParser2 = _interopRequireDefault(_bodyParser);

var _expressHandlebars = require('express-handlebars');

var _expressHandlebars2 = _interopRequireDefault(_expressHandlebars);

var _controllers = require('./controllers');

var _controllers2 = _interopRequireDefault(_controllers);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _connectBusboy = require('connect-busboy');

var _connectBusboy2 = _interopRequireDefault(_connectBusboy);

var _portfinder = require('portfinder');

var _portfinder2 = _interopRequireDefault(_portfinder);

var _cliColor = require('cli-color');

var _cliColor2 = _interopRequireDefault(_cliColor);

var _openurl = require('openurl');

var _openurl2 = _interopRequireDefault(_openurl);

var _cli = require('../cli');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var abePort = null;

if (process.env.ROOT) _cli.config.root = process.env.ROOT;
if (process.env.PORT) abePort = process.env.PORT;

var html = _expressHandlebars2.default.create({
  extname: '.' + _cli.config.files.templates.extension,
  helpers: {
    abe: _cli.compileAbe,
    printInput: _cli.printInput,
    moduloIf: _cli.moduloIf,
    testObj: _cli.testObj,
    closeBlock: _cli.closeBlock,
    subBlock: _cli.subBlock,
    openBlock: _cli.openBlock,
    isSubBlock: _cli.isSubBlock,
    notEmpty: _cli.notEmpty,
    printJson: _cli.printJson,
    className: _cli.className,
    attrAbe: _cli.attrAbe,
    folders: _cli.folders,
    printConfig: _cli.printConfig
  }
});

_portfinder2.default.getPort(function (err, freePort) {
  var app = (0, _express2.default)();
  var port = abePort !== null ? abePort : freePort || 3000;

  app.set('views', _path2.default.join(__dirname, '/templates'));

  // app.set('template', )
  app.engine('.html', html.engine);
  app.set('view engine', '.html');

  app.locals.layout = false;

  app.use(_express2.default.static(__dirname + '/public'));
  _cli.FileParser.copySiteAssets();

  var sites = _cli.FileParser.getFolders(_cli.config.root.replace(/\/$/, ""), false, 0);
  var publish = _cli.fileUtils.concatPath(_cli.config.root, _cli.config.publish.url);
  app.use(_express2.default.static(publish));

  app.use(_express2.default.static(__dirname + '/node_modules/handlebars/dist'));
  app.use((0, _connectBusboy2.default)());
  app.use(_bodyParser2.default.json());
  app.use(_bodyParser2.default.urlencoded({ extended: true }));
  app.use(_controllers2.default);

  app.listen(port, function () {
    console.log(_cliColor2.default.green('\nserver running at http://localhost:' + port + '/'));
    if (process.env.OPENURL) _openurl2.default.open('http://localhost:' + port + '/abe/');
  });
});